//=============================================================================
// WpLoaderBase.
// La localizacin de los jc y wp no puede ser Vect(0,0,0)
//
// For testing purposes, do not modify or redistribute
// Have suggestions? Contact me.
// caco_fff@hotmail.com - Higor at UT99.org
//=============================================================================
class WpLoaderBase expands InfoPoint;

const ZeroVect = Vect(0,0,0);
const BPOclass = class'BotzPathObject';

struct WpInfo
{
	var() vector BwpLoc;
	var() name BwpTag;
	var() name ConnectWith;	//Forzado para evitar errores con WP's indeseables muy cercanos
	var() name IgnoredWp;	//Lo mismo, arriba forzada una coneccin, abajo se evita tal
	var() name MarkedTeleporter; //Debe usarse en conjuncion con ConnectWith
	var() name MarkedLift;	//Va el Name, no el tag (Hay muchos ascensores sin tag)
	var() bool NoLink;
	var() JtJInfo MyJTJ;
};

struct JunctionInfo
{
	var() vector JcLoc;
	var() name JcTag;
	var() name IgnoreConnection;
	var() bool PreTouch;
	var() bool Goal;
	var() JtJInfo MyJTJ;
//Ahh, array en array es invalido, debo averiguar un metodo de automatizacin de caminos.
//	NO: var() name BestPath[40];		Todo esto es muy trabajoso =( , al principio
//		var() name DefinedGoals[40];	pero saben, una vez terminado, todo sera muy facil.
//		var() name TacticalAlt[40];	Debo programar para metodo automatico
//	Definir tactical alt... y si coloco un auto definidor cada x tiempo?, viendo cuando un camino se bloquea o no en T real?
//	De paso, utilizar estos wp para redeemer?
};

var() JunctionInfo Junciones[60];
var() WpInfo Waypoints[700];

var MasterGasterFer Master;


var() bool bLinkWps;
var() bool bConnect;
var() bool bCheckConnections;
var() bool bJunctionIdentify;
var() bool bLinkJunctions;
var() bool bSetFinalPaths;
var bool bFinalPathsReady;
var bool bGlobalChanged;

var BotzJunction JunctionList[61];
var int IterateCount, bestPl, bestPk;

final function BeginTheWpProcess()
{

	CreateWayPoints();	//Creacin y configuracin de los Wp nuevos

	if (bLinkWps)
		LinkNamedWps();	//Se identifican los caminos no deseados y se fuerzan conecciones.
	else
		return;

	if (bConnect)
		StartConnections();	//Unir(conectar) los BotzWp
	else
		return;

	if (bCheckConnections)
		CheckConnections();
	else
		return;

	if (bJunctionIdentify)
		IdentifyJunctions();//Permitir creacion de PathInfo y ver entre que junciones estan.
	else
		return;

	if (bLinkJunctions)
		LinkJunctions();	//Une los Wp a las junciones y permiten su interconeccin
	else
		return;

//	if ( bSetFinalPaths )
//		SetBestPaths();		//Paso final supremo

}

final function EnforceWp()
{
		if ( bGlobalChanged )
			BestPathsCont();
		if ( bestPl == 0 )
			BestPathsInit();
}

final function BestPathsInit()
{
	local int i, k, l;
	local BotzJunction BJ, AJ, Trail[60];
	local BotzPathObject BPOa, BPOb, BPOc;

	// Primero: Sealar caminos y crear los correspondientes PathObjects
	ForEach AllActors (class'BotzJunction', BJ)
	{
		l++;
		if ( BJ.IsA('BotzGoal') )
			continue;
		For (i=0 ; i<60 ; i++)
		{
			l++;
			if ( BJ.DefinedGoals[i] == none )
				break;
			if ( BJ.BestPath[i] != none )
			{
				Trail[0] = BJ;
				Trail[1] = BJ.BestPath[i];
				BPOa = class'BotzPathObject'.Static.Init( Trail, False, False);
				k++;
				BJ.BestObjects[i] = BPOa;
//				BPOa.ReportIn();

			}
			BPOa = none;
			if ( (BJ.PresetTransloc[i] != none) && (BJ.PresetJump[i] == none) )
			{
				Trail[0] = BJ;
				Trail[1] = BJ.PresetTransloc[i];
				BPOa = class'BotzPathObject'.Static.Init( Trail, True, False);
				k++;
				BJ.TranslocObjects[i] = BPOa;
//				BPOa.ReportIn();
			}
			if ( (BJ.PresetTransloc[i] == none) && (BJ.PresetJump[i] != none) )
			{
				Trail[0] = BJ;
				Trail[1] = BJ.PresetJump[i];
				BPOa = class'BotzPathObject'.Static.Init( Trail, False, True);
				k++;
				BJ.JumpObjects[i] = BPOa;
//				BPOa.ReportIn();
			}
			if ( (BJ.PresetTransloc[i] != none) && (BJ.PresetJump[i] != none) )
			{
				Trail[0] = BJ;
				Trail[1] = BJ.PresetJump[i];
				BPOa = class'BotzPathObject'.Static.Init( Trail, True, True);
				BJ.JumpObjects[i] = BPOa;
				BJ.TranslocObjects[i] = BPOa;
				k += 2;
//				BPOa.ReportIn();
			}
		}
	}
	bGlobalChanged = True; //START!
	bestPk += k;
	bestPl += l;
	Log("Initialized BESTPATHS");
}


final function BestPathsCont()
{
	local int i, j, k, l, ii;
	local float d;
	local BotzJunction BJ, AJ, Trail[60];
	local BotzPathObject BPOa, BPOb, BPOc;

	bGlobalChanged = False;
	l++;
	ForEach AllActors (class'BotzJunction', BJ)
	{
		l++;
		if ( BJ.IsA('BotzGoal') )
			continue;

		For ( i=0 ; i<8 ; i++ )
		{	l++;
			AJ = BJ.LinkedJunctions[i];
			if (AJ == none)
				break;
			For ( ii=0 ; ii<60 ; ii++ )
			{	l++;
				if ( AJ.DefinedGoals[ii] == none)
					break;
				if (AJ.DefinedGoals[ii] == BJ)
					continue;
				if (AJ.BestPath[ii] != none)
				{
					Trail[0] = BJ;
					For ( j=1 ; j<60 ; j++ )
					{
						l++;
						Trail[j] = AJ.BestObjects[ii].Trail[j-1];
						if ( Trail[j] == none )
							break;
					}
					BPOb = BPOclass.static.Init( Trail , False, False);
					j = BPOb.FindI( BJ.DefinedGoals, AJ.DefinedGoals[ii]);
					if ( J == -1 )
					{
						Log("CountI sali con -1, en la lista de Goals de"@GetItemName( string(BJ) )@"no aparece"@GetItemName( string(AJ.DefinedGoals[ii]) ) );
						continue;
					}
					l += j;
					BPOa = BJ.BestObjects[j];
					BPOc = BPOclass.static.GetBestNormalPath( BPOa, BPOb);
					if (BPOa == BPOb)	//Si B es A sigue todo como es
						break;
					if (BPOc == BPOb)	//Si el mejor es B, re-iterar para la prxima
					{
						BJ.TacticalAlt[j] = BJ.BestPath[j];
						BJ.BestObjects[j] = BPOc;
						BJ.BestPath[j] = BPOc.Trail[1];
						bGlobalChanged = True;
					}
					if (BJ.PresetTransloc[j] != none)	//Ver si translocalizarse o seguir
					{
						BPOa = BJ.TranslocObjects[j];
						BPOc = BPOclass.static.GetBestTranslocPath( BPOa, BPOb);
						if ( BPOc == BPOb )
						{
							BJ.PresetTransloc[j] = BPOc.Trail[1];
							BJ.TranslocObjects[j] = BPOc;
							bGlobalChanged = True;
						}
					}
					if (BJ.PresetJump[j] != none)	//Ver si pegar un buen salto o seguir
					{
						BPOa = BJ.JumpObjects[j];
						BPOc = BPOclass.static.GetBestJumpPath( BPOa, BPOb);
						if ( BPOc == BPOb )
						{
							BJ.PresetJump[j] = BPOc.Trail[1];
							BJ.TranslocObjects[j] = BPOc;
							bGlobalChanged = True;
						}
					}
//					BPOc.ReportIn();
				}
			}
		}

	}
	bestPl += l;
	if (bGlobalChanged)
		return;
	Log("Debug: hubo unas"@bestPl@"iteraciones en SetBestPaths secuencial");
	Log("Debug: se han creado unos"@bestPk@"BotzPathObjects");
	IterateCount += bestPl;
	log("Hubo unas"@IterateCount@"iteraciones en WpLoaderBase");
}

final function CreateWayPoints()
{
	local int MaxX, i;
	local BotzJunction J;
	local BotzWp Bwp;

	MaxX = GetJunctionNum();
	For ( i=0 ; i<MaxX ; i++ )
	{
		if ( Junciones[i].Goal )
			J = Spawn(class'BotzGoal',, Junciones[i].JcTag, Junciones[i].JcLoc );
		else
		{
			J = Spawn(class'BotzJunction',, Junciones[i].JcTag, Junciones[i].JcLoc );
			J.PreTouch = Junciones[i].PreTouch;
		}
		J.IgnoredName = Junciones[i].IgnoreConnection;
		J.JtJ = Junciones[i].MyJtJ;
	}
	Log("Se crearon exitosamente unas"@MaxX@"junciones en"@Master.LevelName);
	IterateCount += MaxX * 2;

	MaxX = GetWpNum();
	For (i=0;i<MaxX;i++)
	{
		Bwp = Spawn(class'BotzWp',,Waypoints[i].BwpTag,Waypoints[i].BwpLoc);
		Bwp.MustConnect = Waypoints[i].ConnectWith;
		Bwp.NeverConnectName = Waypoints[i].IgnoredWp;
		Bwp.Nolink = Waypoints[i].NoLink;
		Bwp.JtJ = Waypoints[i].MyJtJ;
		if (Waypoints[i].MarkedLift != '')
			Bwp.MyLift = FindMover(Waypoints[i].Markedlift);
		if (Waypoints[i].MarkedTeleporter != '')
			ForEach AllActors (class'Teleporter', Bwp.TeleP, Waypoints[i].MarkedTeleporter)
				break;
	}

	i = 0;
	ForEach AllActors (class'BotzJunction', J)
	{
		IterateCount++;
		if (J.IsA('BotzGoal') )
			continue;
		JunctionList[i] = J;
		++i;
	}

	Log("Se crearon exitosamente unos"@MaxX@"waypoints en"@Master.LevelName);
	IterateCount += MaxX * 2;
}

final function CheckConnections()
{
	local BotzWp Bwp;
	local string Erreur;
	local bool bErrated;

	ForEach AllActors(class'BotzWp', bwp)
	{
		IterateCount++;
		if ( !AlreadyLinked(bwp) )
		{
			if ( (bwp.Tag == '') || (bwp.Tag == 'BotzWp') )
				Erreur = "cuya ubicacin es: X"@string(int(bwp.Location.X))$", Y"@string(int(bwp.Location.Y))$", Z"@string(int(bwp.Location.Z));
			else
				Erreur = "cuyo BwpTag es"@string(bwp.Tag);
			Log("Advertencia: el BotzWp"@Erreur@"que resulta ser"@bwp@"tuvo conecciones vacias durante CheckConnections()");
			bErrated = True;
			bJunctionIdentify = false;
		}
	}
	if (bErrated)
		Log("<><><> Por lo que se anula el siguiente paso de identificar junciones");
	else
		Log("CheckConnections() finaliz sin ningun error");
}

final function LinkNamedWps()
{
	local BotzWp Bwp;
	local BotzJunction BJ;
	local BaseBotzWp BBWP;
	local int f, v, k;

	ForEach AllActors (class'BotzWp', Bwp)
	{
		k++;
		if (Bwp.MustConnect != '')
			ForEach AllActors (class'BaseBotzWp', BBWP, Bwp.MustConnect)
			{
				k++;
				f++;
				ConnectWp( Bwp, BBWP);
				if ( BBWP.IsA('BotzWp') && !InConnect( BotzWp(BBWP), Bwp) )
				{
					ConnectWp( BotzWp(BBWP), Bwp);
					f++;
				}
				break;
			}
		BBWP = none;
		if (Bwp.NeverConnectName != '')
			ForEach AllActors (class'BaseBotzWp', Bwp.NeverConnect, Bwp.NeverConnectName)
			{
				k++;
				v++;
				break;
			}
	}

	Bwp = none;
	ForEach AllActors (class'BotzJunction', BJ)
	{
		k++;
		if ( BJ.IgnoredName != '' )
			ForEach AllActors (class'BotzWp', BJ.IgnoredWp, BJ.IgnoredName)
			{
				k++;
				v++;
				break;
			}
	}
	Log("Se forzaron"@f@"conecciones de BotzWp y se evitaron unas"@v@"de ellas");
	Log("Debug: hubo"@k@"iteraciones en LinkNamedWps()");
	IterateCount += k;
}

final function StartConnections()	//Junciones se autoconectan =), o no
{
	local BotzWp bwp1;
	local BaseBotzWp BBwp1;
	local int k;

	//Primero, encontrar los Wp
	ForEach AllActors (class'BotzWp', bwp1)
	{
		k++;
		if ( AlreadyLinked(bwp1) )
			continue; //Ya est unido a otros 2
		BBwp1 = FindBestWpFor( bwp1);
		if ( InConnect( bwp1, BBwp1) )
			BBwp1 = FindBestWpFor( bwp1, BBwp1);
		ConnectWp( bwp1, BBwp1);
		if ( BBwp1.IsA('BotzWp') &&  !InConnect( BotzWp(BBwp1) , bwp1) )
			ConnectWp( BotzWp(BBwp1), bwp1);

		if ( AlreadyLinked(bwp1) )
			continue;	// Me falto otra conexin, NEW, correccion de un BUG
		BBwp1 = FindBestWpFor( bwp1);
		if ( InConnect( bwp1, BBwp1) )
			BBwp1 = FindBestWpFor( bwp1, BBwp1);
		ConnectWp( bwp1, BBwp1);
		if ( BBwp1.IsA('BotzWp') &&  !InConnect( BotzWp(BBwp1) , bwp1) )
			ConnectWp( BotzWp(BBwp1), bwp1);
	}
	Log("Fin de StartConnections(), si hay mensajes de advertencia arriba de este, verlos atentamente");
	IterateCount += k;
}

final function IdentifyJunctions()
{
	local BotzJunction BJ, BjS[2];
	local BotzWp Base, BpList[32];
	local int i, j, f, k, c;
	local bool bNoCambia;
	local bool bFirst;

	ForEach AllActors (class'BotzWp', Base)
	{
		IterateCount++;
		if (AlreadyJunctioned(Base) )
			continue;

		BpList[0] = none; //Optimizacion anti x32 iteracion
		BpList[1] = none;
		BpList[2] = none;
		BpList[3] = none;
		BpList[4] = none;
		BpList[5] = none;
		BpList[6] = none;
		BpList[7] = none;
		BpList[8] = none;
		BpList[9] = none;
		BpList[10] = none;
		BpList[11] = none;
		BpList[12] = none;
		BpList[13] = none;
		BpList[14] = none;
		BpList[15] = none;
		BpList[16] = none;
		BpList[17] = none;
		BpList[18] = none;
		BpList[19] = none;
		BpList[20] = none;
		BpList[21] = none;
		BpList[22] = none;
		BpList[23] = none;
		BpList[24] = none;
		BpList[25] = none;
		BpList[26] = none;
		BpList[27] = none;
		BpList[28] = none;
		BpList[29] = none;
		BpList[30] = none;
		BpList[31] = none;

		BjS[0] = none; //Optimizacion anti x2 iteracion
		BjS[1] = none;

		FindEntirePath( Base, BpList);
		if (BpList[0].Nodes[0].IsA('BotzJunction')&& BpList[0].Nodes[1].IsA('BotzJunction'))
		{
			For ( i=0 ; i<2 ; i++)
				BpList[0].Junctions[i] = BotzJunction( BpList[0].Nodes[i]);
			IterateCount += 2;
			j++;
		}
		else
		{
			f = f+2;
			FindTheJuncs( BpList, BjS);
			For ( i=0 ; i<GetIn(BpList) ; i++ )
			{
				IterateCount++;
				BpList[i].Junctions[0] = BjS[0];
				BpList[i].Junctions[1] = BjS[1];
			}
		}
		c++;
	}

	ForEach AllActors (class'BotzWp', Base)
	{
		IterateCount++;
		if ( !AlreadyJunctioned(Base) )
		{
			Log("Advertencia:"@GetItemName(string(Base))@"no tiene ambas junciones identificadas");
			k++;
		}
	}

	Log("Fin de IdentifyJunctions(), si hay mensajes de advertencia arriba de este, verlos atentamente");
	Log("Hay"@j@"BotzWp con 2 junciones como extremos");
	Log("Hay"@f@"BotzWp con 1 juncion como extremo");
	Log("Se hicieron un total de"@c@"recursiones de chequeo (una por camino) ");
	if ( k == 0 )
		Log("No hay Wp's erroneos");
	else
	{
		Log("Hay"@k@"BotzWp con conecciones faltantes, se anula el proximo paso");
		bLinkJunctions = False;
	}
//	IterateCount += c;
}
/*
final function SetBestPaths()	//Paso final supremo, este se encargar de que cada waypoint pueda decirle al bot cual es el mejor camino hacia un objetivo que puede ser cualquier punto en el nivel, depender de un mximo de 61 recursiones, hay hasta 61 junciones como mximo (61 menos la seleccionada, dan 60: el numero soportado por mi motor)
{
	local int i, j, k, l, ii;
	local float d;
	local BotzJunction BJ, AJ, Trail[60];
	local BotzPathObject BPOa, BPOb, BPOc;
	local bool bChanged;

	// Primero: Sealar caminos y crear los correspondientes PathObjects
	ForEach AllActors (class'BotzJunction', BJ)
	{
		l++;
		if ( BJ.IsA('BotzGoal') )
			continue;
		For (i=0 ; i<60 ; i++)
		{
			l++;
			if ( BJ.DefinedGoals[i] == none )
				break;
			if ( BJ.BestPath[i] != none )
			{
				Trail[0] = BJ;
				Trail[1] = BJ.BestPath[i];
				BPOa = class'BotzPathObject'.Static.Init( Trail, False, False);
				k++;
				BJ.BestObjects[i] = BPOa;
				BPOa.ReportIn();

			}
			BPOa = none;
			if ( (BJ.PresetTransloc[i] != none) && (BJ.PresetJump[i] == none) )
			{
				Trail[0] = BJ;
				Trail[1] = BJ.PresetTransloc[i];
				BPOa = class'BotzPathObject'.Static.Init( Trail, True, False);
				k++;
				BJ.TranslocObjects[i] = BPOa;
				BPOa.ReportIn();
			}
			if ( (BJ.PresetTransloc[i] == none) && (BJ.PresetJump[i] != none) )
			{
				Trail[0] = BJ;
				Trail[1] = BJ.PresetJump[i];
				BPOa = class'BotzPathObject'.Static.Init( Trail, False, True);
				k++;
				BJ.JumpObjects[i] = BPOa;
				BPOa.ReportIn();
			}
			if ( (BJ.PresetTransloc[i] != none) && (BJ.PresetJump[i] != none) )
			{
				Trail[0] = BJ;
				Trail[1] = BJ.PresetJump[i];
				BPOa = class'BotzPathObject'.Static.Init( Trail, True, True);
				BJ.JumpObjects[i] = BPOa;
				BJ.TranslocObjects[i] = BPOa;
				k += 2;
				BPOa.ReportIn();
			}
		}
	}
	BJ = none;
	BPOa = none;
	Trail[0] = none;
	Trail[1] = none;

While (True)
{	bChanged = False;
	l++;
	ForEach AllActors (class'BotzJunction', BJ)
	{
		l++;
		if ( BJ.IsA('BotzGoal') )
			continue;

		For ( i=0 ; i<8 ; i++ )
		{	l++;
			AJ = BJ.LinkedJunctions[i];
			if (AJ == none)
				break;
			For ( ii=0 ; ii<60 ; ii++ )
			{	l++;
				if ( AJ.DefinedGoals[ii] == none)
					break;
				if (AJ.DefinedGoals[ii] == BJ)
					continue;
				if (AJ.BestPath[ii] != none)
				{
					Trail[0] = BJ;
					For ( j=1 ; j<60 ; j++ )
					{
						l++;
						Trail[j] = AJ.BestObjects[ii].Trail[j-1];
						if ( Trail[j] == none )
							break;
					}
					BPOb = BPOclass.static.Init( Trail , False, False);
					j = BPOb.FindI( BJ.DefinedGoals, AJ.DefinedGoals[ii]);
					if ( J == -1 )
					{
						Log("CountI sali con -1, en la lista de Goals de"@GetItemName( string(BJ) )@"no aparece"@GetItemName( string(AJ.DefinedGoals[ii]) ) );
						continue;
					}
					l += j;
					BPOa = BJ.BestObjects[j];
					BPOc = BPOclass.static.GetBestNormalPath( BPOa, BPOb);
					if (BPOa == BPOb)	//Si B es A sigue todo como es
						break;
					if (BPOc == BPOb)	//Si el mejor es B, re-iterar para la prxima
					{
						BJ.TacticalAlt[j] = BJ.BestPath[j];
						BJ.BestObjects[j] = BPOc;
						BJ.BestPath[j] = BPOc.Trail[1];
						bChanged = True;
					}
					if (BJ.PresetTransloc[j] != none)	//Ver si translocalizarse o seguir
					{
						BPOa = BJ.TranslocObjects[j];
						BPOc = BPOclass.static.GetBestTranslocPath( BPOa, BPOb);
						if ( BPOc == BPOb )
						{
							BJ.PresetTransloc[j] = BPOc.Trail[1];
							BJ.TranslocObjects[j] = BPOc;
							bChanged = True;
						}
					}
					if (BJ.PresetJump[j] != none)	//Ver si pegar un buen salto o seguir
					{
						BPOa = BJ.JumpObjects[j];
						BPOc = BPOclass.static.GetBestJumpPath( BPOa, BPOb);
						if ( BPOc == BPOb )
						{
							BJ.PresetJump[j] = BPOc.Trail[1];
							BJ.TranslocObjects[j] = BPOc;
							bChanged = True;
						}
					}
					BPOc.ReportIn();
				}
			}
		}

	}
	if (!bChanged)
		break;
}
	Log("Debug: hubo unas"@l@"iteraciones en SetBestPaths");
	Log("Debug: se han creado unos"@k@"BotzPathObjects");
	IterateCount += l;
}
*/
final function LinkJunctions()	//Uso las funciones ya creadas en los Wp mismos =)
//Esta funcin fue revisada y es segura, en caso de errores, no mire aca.
{
	local BaseBotzWp BBWP;
	local BotzJunction BJ;
	local BotzWp BWP;
	local int f, i;
	local bool bOneLess;

	ForEach AllActors (class'BotzJunction', BJ)
	{
		IterateCount++;
		if ( !BJ.IsA('BotzGoal') && (BJ.DefinedGoals[0] == none) )
		{
			bOneLess = False;
			For ( i=0 ; i<60 ; i++ )
			{	IterateCount++;
				if ( JunctionList[i] == none )
					break;
				if ( JunctionList[i] == BJ )
					bOneLess = True;
				if (bOneLess)
					BJ.DefinedGoals[i] = JunctionList[i+1];
				else
					BJ.DefinedGoals[i] = JunctionList[i];
			}
		}
	}

	ForEach AllActors (class'BaseBotzWP', BBWP)
	{
		IterateCount++;
		BBWP.InitializeWp();
	}

	ForEach AllActors (class'BotzWp', BWP)
	{	IterateCount++;
		if ( BWP.PathInfo == none )
		{
			f++;
			BWP.StartPathInfo();
		}
	}
	bFinalPathsReady = True;
	Log("Se crearon unos"@f@"PathInfo, lo que indica la presencia de"@f@"caminos");

}

final function int GetJunctionNum()
{
	local int result;

	result = 0;
	While ( Junciones[result].JcLoc != ZeroVect )
		result++;
	return result;
}
final function int GetWpNum()
{
	local int result;

	result = 0;
	While ( Waypoints[result].BwpLoc != ZeroVect )
		result++;
	return result;
}

static final function ConnectWp( BotzWp Base, BaseBotzWp Target)
{
	local int i;

	if ( Target.IsA('BotzPathInfo'))
		return;
	if ( AlreadyLinked(Base) )
	{
		Log("Advertencia: Se intento conectar de Wp lleno"@Base@"a"@Target);
		return;
	}
	if (Target == Base)
	{
		Log("Advertencia: se trat de conectar un Wp a si mismo:"@Base);
		return;
	}
	if (Target == Base.NeverConnect)
	{
		Log("Advertencia: Se llam ConnectWp desde Base a NeverConnect!, revisar scripts");
		Log("<><><><>- La base es"@Base@"y NeverConnect es"@Target);
		return;
	}
	Base.Nodes[GetCNum(Base)] = Target;
}
static final function int GetCNum( BotzWp C)
{
	local int i;

	For (i=0 ; i<2 ; i++)
		if (C.Nodes[i] == none)
			break;
	return i;
}
static final function bool AlreadyLinked( BotzWp C)
{
	return (GetCNum(C) == 2);
}
final function BaseBotzWp FindBestWpFor( BotzWp Base, optional BaseBotzWp Exclusion)
{
	local BaseBotzWp Result, Test;
	local float Dist, BDist;

	BDist = 6000;
	ForEach Base.RadiusActors (class'BaseBotzWp', Test, 6000, Base.Location)
	{
		IterateCount++;
		if ( Test == Base )
			continue;
		if ( (Test == Exclusion) || (Base.NeverConnect == Test) )
			continue;
		if ( Test.IsA('BotzWp') && (BotzWp(Test).NeverConnect == Base) )
			continue;
		if ( Test.IsA('BotzWp') && AlreadyLinked(BotzWP(Test) ) )
			continue;
		if ( Test.IsA('BotzJunction') && ( BotzJunction(Test).IgnoredWp == Base) )
			continue;
		if ( Test.IsA('BotzPathInfo') )
			continue;
		if ( !Test.FastTrace(Base.Location) )
			continue;
		Dist = VSize(Test.Location - Base.Location);
		if (Dist < BDist)
		{
			BDist = Dist;
			Result = Test;
		}
	}
	if (Result == none)
		Log("Advertencia: No hay un Wp cerca de"@Base);
	return Result;
}
static final function bool InConnect(BotzWp Base, BaseBotzWp Other)
{
	return ( (Base.Nodes[0] == Other) || (Base.Nodes[1] == Other) );
}
static final function bool AlreadyJunctioned(BotzWp Base)
{
	return (GetJNum(Base) == 2);
}
static final function int GetJNum(BotzWp Base)
{
	local int i;

	For (i=0 ; i<2 ; i++)
		if (Base.Junctions[i] == none)
			break;
	return i;
}
static final function BotzJunction JAnalize(BotzWp Base)
{
	if (Base.Nodes[0].IsA('BotzJunction') )
		return BotzJunction(Base.Nodes[0]);
	if (Base.Nodes[1].IsA('BotzJunction') )
		return BotzJunction(Base.Nodes[1]);
	return none;
}
static final function bool InJunc(BotzWp Base, BotzJunction Other)
{
	return ( (Base.Junctions[0] == Other) || (Base.Junctions[1] == Other) );
}
static final function BotzJunction BjGet(BotzWp Base, optional BotzJunction Exclude)
{
	local int i;

	For ( i=0 ; i<2 ; i++ )
		if ( (Base.Junctions[i] != none) && (Base.Junctions[i] != Exclude) )
			return Base.Junctions[i];
	return none;
}

final function Mover FindMover(name AName)
{
	local mover TheMover;

	ForEach AllActors (class'Mover', TheMover)
	{
		IterateCount++;
		if (TheMover.Name == AName)
			return TheMover;
	}
	Log("Advertencia: no se encontro un mover con nombre"@AName);
	return none;
}
final function FindEntirePath( BotzWp Sample, out BotzWp TheList[32])
{
	local BotzWp Zambos;
	local int i, j;
	local bool bNoChange;

	TheList[0] = Sample;

	if ( Sample.Nodes[0].IsA('BotzJunction') && Sample.Nodes[1].IsA('BotzJunction') )
		return;

	Do
	{
		bNoChange = True;
		For ( j=0; j<32; j++)
		{
			IterateCount++;
			if (TheList[j] == none)
				continue;
			For ( i=0; i<2; i++)
			if (TheList[j].Nodes[i].IsA('BotzWp') && !IsInList(TheList[j].Nodes[i],TheList))
			{
				TheList[GetIn(TheList)] = BotzWp(TheList[j].Nodes[i]);
				bNoChange = False;
			}
			IterateCount += 2;
		}
		if (bNoChange)
			break;
	} Until (True)
}
final function FindTheJuncs( BotzWp TheList[32], out BotzJunction Juncs[2])
{
	local int i, s;

	For ( i=0 ; i<32 ; i++ )
	{
		IterateCount++;
		if (TheList[i] == none)
			return;
		if ( JAnalize(TheList[i]) != none )
		{
			Juncs[s] = JAnalize(TheList[i]);
			s++;
		}
	}
}

final function int GetIn( Object L[32])
{
	local int w;

	if ( L[16] != none )
		For (w=31; w>-1; w--)
		{
			IterateCount++;
			if ( L[w] != none)
				return w+1;
		}


	For ( w=0; w<32; w++)
	{
		IterateCount++;
		if ( L[w] == none)
			return w;
	}
}
final function bool IsInList( Object Sample, Object L[32])
{
	local int w;

	For ( w=0; w<32; w++)
	{
		IterateCount++;
		if ( L[w] == Sample)
			return True;
	}
	return False;
}

defaultproperties
{
}
